<template>
  <div class="container-main" ref="main">
    <div class="search-hearder" ref="topSearch">
      <el-form
        :model="queryParams"
        ref="queryForm"
        :inline="true"
        v-show="showSearch"
        label-width="auto"
      >
        <!-- <el-form-item label="${comment}" prop="id">
                    <el-input
                        v-model="queryParams.id"
                        placeholder="请输入${comment}"
                        clearable
                        size="small"
                        @keyup.enter.native="handleQuery"
                    />
                  </el-form-item> -->
        <el-form-item label="区域" prop="areaId">
          <el-select
            v-model="queryParams.areaId"
            placeholder="请选择区域"
            clearable
            size="small"
          >
            <el-option
              v-for="dict in dict.type.tc_area"
              :key="dict.value"
              :label="dict.label"
              :value="dict.value"
            />
          </el-select>
        </el-form-item>
        <el-form-item label="日期">
          <el-date-picker
            v-model="daterangeDateTime"
            size="small"
            style="width: 240px"
            value-format="yyyy-MM-dd"
            type="daterange"
            range-separator="-"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
          ></el-date-picker>
        </el-form-item>
        <!-- <el-form-item label="创建时间">
          <el-date-picker
            v-model="daterangeCreateTime"
            size="small"
            style="width: 240px"
            value-format="yyyy-MM-dd"
            type="daterange"
            range-separator="-"
            start-placeholder="开始日期"
            end-placeholder="结束日期"
          ></el-date-picker>
        </el-form-item> -->
        <el-form-item>
          <el-button
            type="primary"
            icon="el-icon-search"
            size="mini"
            @click="handleQuery"
            >搜索</el-button
          >
          <el-button icon="el-icon-refresh" size="mini" @click="resetQuery"
            >重置</el-button
          >
        </el-form-item>
      </el-form>
    </div>
    <div class="layui-table-tool" ref="tableTool">
      <el-button
        type="primary"
        size="mini"
        @click="handleAdd()"
        v-hasPermi="['tcZz/netWorkYq:yqzs:add']"
        >新增</el-button
      >
      <el-button
        type="success"
        size="mini"
        :disabled="single"
        @click="handleUpdate"
        v-hasPermi="['tcZz/netWorkYq:yqzs:edit']"
        >修改</el-button
      >
      <el-button
        type="danger"
        size="mini"
        :disabled="multiple"
        @click="handleDelete"
        v-hasPermi="['tcZz/netWorkYq:yqzs:remove']"
        >删除</el-button
      >
      <el-button type="primary" size="mini" @click="importFiles"
        >导入</el-button
      >
      <el-button
        type="warning"
        size="mini"
        :loading="exportLoading"
        @click="handleExport"
        v-hasPermi="['tcZz/netWorkYq:yqzs:export']"
        >导出</el-button
      >
    </div>
    <el-table
      v-loading="loading"
      :data="yqzsList"
      @selection-change="handleSelectionChange"
    >
      <el-table-column type="selection" width="55" align="center" />
      <!-- <el-table-column label="序号" align="center" prop="id" /> -->
      <el-table-column label="区域" align="center" prop="areaId">
        <template slot-scope="scope">
          <dict-tag :options="dict.type.tc_area" :value="scope.row.areaId" />
        </template>
      </el-table-column>
      <el-table-column label="日期" align="center" prop="dateTime" width="180">
        <template slot-scope="scope">
          <span>{{ parseTime(scope.row.dateTime, "{y}-{m}-{d}") }}</span>
        </template>
      </el-table-column>
      <!-- <el-table-column label="备注" align="center" prop="remark" /> -->
      <el-table-column label="非敏感数量" align="center" prop="count1" />
      <el-table-column label="敏感数量" align="center" prop="count2" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
        width="200"
        fixed="right"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            @click="handleInfo(scope.row)"
            v-hasPermi="['tcZz/netWorkYq:yqzs:list']"
          >
            查看
          </el-button>
          <el-button
            type="success"
            size="mini"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['tcZz/netWorkYq:yqzs:edit']"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="danger"
            @click="handleDelete(scope.row)"
            v-hasPermi="['tcZz/netWorkYq:yqzs:remove']"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total > 0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改舆情走势图对话框 -->
    <el-dialog
      :visible.sync="open"
      width="500px"
      append-to-body
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ title }}</div>
      <el-form
        ref="form"
        :model="form"
        :rules="rules"
        label-width="auto"
        class="dialog-from"
      >
        <el-form-item label="区域" prop="areaId">
          <el-select v-model="form.areaId" placeholder="请选择区域">
            <el-option
              v-for="dict in dict.type.tc_area"
              :key="dict.value"
              :label="dict.label"
              :value="parseInt(dict.value)"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="日期" prop="dateTime">
          <el-date-picker
            clearable
            size="small"
            v-model="form.dateTime"
            type="date"
            value-format="yyyy-MM-dd"
            placeholder="选择日期"
          >
          </el-date-picker>
        </el-form-item>

        <el-form-item label="非敏感数量" prop="count1">
          <el-input v-model="form.count1" placeholder="请输入非敏感数量" />
        </el-form-item>
        <el-form-item label="敏感数量" prop="count2">
          <el-input v-model="form.count2" placeholder="请输入敏感数量" />
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
    <!--查看舆情走势图详情页-->
    <el-dialog
      :visible.sync="infoOpen"
      width="90%"
      append-to-body
      :close-on-click-modal="false"
      :destroy-on-close="true"
      custom-class="dialog-box"
    >
      <div slot="title" class="dialog-title">{{ infoTitle }}</div>

      <el-descriptions
        title="舆情走势图"
        :column="2"
        border
        labelClassName="desLable"
      >
        <el-descriptions-item label="区域">{{
          selectDictLabel(dict.type.tc_area, form.areaId)
        }}</el-descriptions-item>

        <el-descriptions-item label="日期">{{
          form.dateTime
        }}</el-descriptions-item>

        <el-descriptions-item label="非敏感数量">{{
          form.count1
        }}</el-descriptions-item>

        <el-descriptions-item label="敏感数量">{{
          form.count2
        }}</el-descriptions-item>
        <el-descriptions-item label="备注">{{
          form.remark
        }}</el-descriptions-item>
      </el-descriptions>
    </el-dialog>
    <!-- 导入 -->
    <el-dialog
      :visible.sync="fileOpen"
      width="400px"
      append-to-body
      custom-class="dialog-box"
      @close="cancelFile"
    >
      <div slot="title" class="dialog-title">导入</div>
      <el-upload
        ref="upload"
        :limit="limit"
        action="666"
        :accept="accept"
        :headers="headers"
        :file-list="fileList"
        :multiple="false"
        :auto-upload="false"
        drag
        :before-upload="handleBeforeUpload"
        :on-exceed="handleExceed"
        :http-request="handleFile"
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link
            type="primary"
            :underline="false"
            style="font-size: 12px; vertical-align: baseline"
            @click="importTemplate"
            >下载模板</el-link
          >
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFile">确 定</el-button>
        <el-button @click="cancelFile">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listYqzs,
  getYqzs,
  delYqzs,
  addYqzs,
  updateYqzs,
  exportYqzs,
  importYqzs
} from "@/api/tcZz/netWorkYq/yqzs";
import { getToken } from "@/utils/auth";

export default {
  name: "Yqzs",
  //注释字典
  dicts: ["tc_area"],
  data() {
    return {
      tableHeigth: 0,
      //查看详情
      infoOpen: false,
      //详情标题
      infoTitle: "",
      // 遮罩层
      loading: true,
      // 导出遮罩层
      exportLoading: false,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 舆情走势图表格数据
      yqzsList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 敏感数量时间范围
      daterangeDateTime: [],
      // 敏感数量时间范围
      daterangeCreateTime: [],
      // 敏感数量时间范围
      daterangeUpdateTime: [],
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        isOrthodox:2
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {
        areaId: [{ required: true, message: "请选择区域", trigger: "blur" }],
        dateTime: [{ required: true, message: "请选择日期", trigger: "blur" }],
        count1: [
          { required: true, message: "请输入非敏感数量", trigger: "blur" },
        ],
        count2: [
          { required: true, message: "请输入敏感数量", trigger: "blur" },
        ],
      },
      //===========
      fileList: [],
      limit: 1,
      accept: ".xls,.xlsx",
      fileOpen: false,
      headers: { Authorization: "Bearer " + getToken() },
    };
  },
  created() {
    this.getList();
  },
  methods: {
    //下载模板
    importTemplate() {
      this.download(
        "/tcZz/netWorkYq/yqzs/importTemplate",
        {},
        `舆情走势图模板.xlsx`
      );
    },
    importFiles() {
      this.fileOpen = true;
    },
    submitFile() {
      this.$refs.upload.submit();
    },
    cancelFile() {
      this.fileOpen = false;
    },
    //导入
    handleBeforeUpload(file) {
      // 校检文件类型
      const fileName = file.name.split(".");
      const fileExt = fileName[fileName.length - 1];
      const isTypeOk = this.accept.includes(fileExt);
      if (!isTypeOk) {
        this.$modal.msgError(`文件格式不正确, 请上传${this.accept}格式文件!`);
        return false;
      }
    },
    handleExceed() {
      this.$modal.msgError(`上传文件数量不能超过 ${this.limit} 个!`);
    },
    handleFile(data) {
      this.$modal.loading();
      let form = new FormData();
      form.append("file", data.file);
      importYqzs(form)
        .then((res) => {
          this.fileOpen = false;
          this.$modal.closeLoading();
          this.$modal.msgSuccess("导入成功");
          this.$refs.upload.clearFiles();
          this.getList();
        })
        .catch(() => {
          this.fileOpen = false;
          this.$modal.closeLoading();
          this.$refs.upload.clearFiles();
          this.getList();
        });
    },

    /** 查询舆情走势图列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeDateTime && "" != this.daterangeDateTime) {
        this.queryParams.params["beginDateTime"] = this.daterangeDateTime[0];
        this.queryParams.params["endDateTime"] = this.daterangeDateTime[1];
      }
      console.log(this.queryParams);
      if (null != this.daterangeCreateTime && "" != this.daterangeCreateTime) {
        this.queryParams.params["beginCreateTime"] =
          this.daterangeCreateTime[0];
        this.queryParams.params["endCreateTime"] = this.daterangeCreateTime[1];
      }
      if (null != this.daterangeUpdateTime && "" != this.daterangeUpdateTime) {
        this.queryParams.params["beginUpdateTime"] =
          this.daterangeUpdateTime[0];
        this.queryParams.params["endUpdateTime"] = this.daterangeUpdateTime[1];
      }
      listYqzs(this.queryParams).then((response) => {
        this.yqzsList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,

        areaId: null,

        dateTime: null,

        createBy: null,

        createTime: null,

        updateBy: null,

        updateTime: null,

        remark: null,

        count1: null,

        count2: null,
      };
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.daterangeDateTime = [];
      this.daterangeCreateTime = [];
      this.daterangeUpdateTime = [];
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map((item) => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /**查看按钮操作 */
    handleInfo(row) {
      this.reset();
      const id = row.id || this.ids;
      getYqzs(id).then((response) => {
        this.form = response.data;
        this.infoOpen = true;
        this.infoTitle = "查看舆情走势图详情";
      });
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加舆情走势图";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getYqzs(id).then((response) => {
        this.form = response.data;
        this.open = true;
        this.title = "修改舆情走势图";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.form.id != null) {
            updateYqzs(this.form).then((response) => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addYqzs(this.form).then((response) => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      this.$confirm('是否确认删除编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delYqzs(ids);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        })
        .catch(() => {});
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有舆情走势图数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(() => {
          this.download(
            "/tcZz/netWorkYq/yqzs/export",
            {
              ...this.queryParams,
            },
            "舆情走势图_" + new Date().getTime() + ".xlsx"
          );
          this.exportLoading = false;
        })
        .catch(() => {});
    },
  },
};
</script>
